## org.apache.http.nio.protocol
Class HttpAsyncRequestExecutor

    java.lang.Object
      org.apache.http.nio.protocol.HttpAsyncRequestExecutor

All Implemented Interfaces:
  NHttpClientEventHandler

    @Immutable
    public class HttpAsyncRequestExecutor

extends Object
implements NHttpClientEventHandler

`HttpAsyncRequestExecutor` is a fully asynchronous HTTP client side protocol handler based on the NIO (non-blocking) I/O model. `HttpAsyncRequestExecutor` translates individual events fired through the `NHttpClientEventHandler` interface into logically related HTTP message exchanges.

`HttpAsyncRequestExecutor` relies on `HttpProcessor` to generate mandatory protocol headers for all outgoing messages and apply common, cross-cutting message transformations to all incoming and outgoing messages, whereas individual `HttpAsyncRequestExecutionHandler`s are expected to implement application specific content generation and processing. The caller is expected to pass an instance of `HttpAsyncRequestExecutionHandler` to be used for the next series of HTTP message exchanges through the connection context using `HTTP_HANDLER` attribute. HTTP exchange sequence is considered complete when the `HttpAsyncResponseConsumer.isDone()` method returns `true`. The `HttpAsyncRequester` utility class can be used to facilitate initiation of asynchronous HTTP request execution.

The following parameters can be used to customize the behavior of this class:

- `CoreProtocolPNames.WAIT_FOR_CONTINUE`
- `CoreConnectionPNames.SO_TIMEOUT`

Since:
  4.2
See Also:
  `HttpAsyncRequestExecutionHandler`

Field Summary
`static String` `HTTP_HANDLER`

Constructor Summary
`HttpAsyncRequestExecutor()`

Method Summary
`void` `closed(NHttpClientConnection conn)` Triggered when the connection is closed.
`void` `connected(NHttpClientConnection conn, Object attachment)` Triggered when a new outgoing connection is created.
`void` `endOfInput(NHttpClientConnection conn)` Triggered when the connection is closed by the opposite end point (half-closed).
`void` `exception(NHttpClientConnection conn, Exception cause)` Triggered if an error occurs during the HTTP exchange.
`void` `inputReady(NHttpClientConnection conn, ContentDecoder decoder)` Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.
`protected void` `log(Exception ex)` This method can be used to log I/O exception thrown while closing `Closeable` objects (such as `HttpConnection`}).
`void` `outputReady(NHttpClientConnection conn, ContentEncoder encoder)` Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.
`void` `requestReady(NHttpClientConnection conn)` Triggered when the connection is ready to accept a new HTTP request.
`void` `responseReceived(NHttpClientConnection conn)` Triggered when an HTTP response is received.
`void` `timeout(NHttpClientConnection conn)` Triggered when no input is detected on this connection over the maximum period of inactivity.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### HTTP_HANDLER

    public static final String HTTP_HANDLER

See Also:
  Constant Field Values

Constructor Detail

### HttpAsyncRequestExecutor

    public HttpAsyncRequestExecutor()

Method Detail

### connected

    public void connected(NHttpClientConnection conn,
                          Object attachment)
                   throws IOException,
                          HttpException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when a new outgoing connection is created.

  Specified by:
    `connected` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - new outgoing HTTP connection.
    `attachment` - an object that was attached to the session request
  Throws:
    `IOException`
    `HttpException`

### closed

    public void closed(NHttpClientConnection conn)

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when the connection is closed.

  Specified by:
    `closed` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - closed HTTP connection.

### exception

    public void exception(NHttpClientConnection conn,
                          Exception cause)

  Description copied from interface: `NHttpClientEventHandler`
  Triggered if an error occurs during the HTTP exchange.

  Specified by:
    `exception` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that caused an I/O error
    `cause` - exception

### requestReady

    public void requestReady(NHttpClientConnection conn)
                      throws IOException,
                             HttpException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when the connection is ready to accept a new HTTP request. The protocol handler does not have to submit a request if it is not ready.

  Specified by:
    `requestReady` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that is ready to accept a new HTTP request.
  Throws:
    `IOException`
    `HttpException`
  See Also:
    `NHttpClientConnection`

### outputReady

    public void outputReady(NHttpClientConnection conn,
                            ContentEncoder encoder)
                     throws IOException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.

  If the content producer is unable to generate outgoing content, output event notifications can be temporarily suspended using `IOControl` interface (super interface of `NHttpClientConnection`).

  Please note that the `NHttpClientConnection` and `ContentEncoder` objects are not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.

  Specified by:
    `outputReady` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that can accommodate a new portion of the outgoing request content.
    `encoder` - The content encoder to use to write content.
  Throws:
    `IOException`
  See Also:
    `NHttpClientConnection`, `ContentEncoder`, `IOControl`

### responseReceived

    public void responseReceived(NHttpClientConnection conn)
                          throws HttpException,
                                 IOException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when an HTTP response is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP response object.

  If the response received encloses a response entity this method will be followed by a series of `NHttpClientEventHandler.inputReady(NHttpClientConnection, ContentDecoder)` calls to transfer the response content.

  Specified by:
    `responseReceived` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that contains an HTTP response
  Throws:
    `HttpException`
    `IOException`
  See Also:
    `NHttpClientConnection`

### inputReady

    public void inputReady(NHttpClientConnection conn,
                           ContentDecoder decoder)
                    throws IOException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.

  If the content consumer is unable to process incoming content, input event notifications can be temporarily suspended using `IOControl` interface (super interface of `NHttpClientConnection`).

  Please note that the `NHttpClientConnection` and `ContentDecoder` objects are not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume input event notifications when the handler is capable of processing more content.

  Specified by:
    `inputReady` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that can produce a new portion of the incoming response content.
    `decoder` - The content decoder to use to read content.
  Throws:
    `IOException`
  See Also:
    `NHttpClientConnection`, `ContentDecoder`, `IOControl`

### endOfInput

    public void endOfInput(NHttpClientConnection conn)
                    throws IOException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when the connection is closed by the opposite end point (half-closed).

  Specified by:
    `endOfInput` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - half-closed HTTP connection.
  Throws:
    `IOException`

### timeout

    public void timeout(NHttpClientConnection conn)
                 throws IOException

  Description copied from interface: `NHttpClientEventHandler`
  Triggered when no input is detected on this connection over the maximum period of inactivity.

  Specified by:
    `timeout` in interface `NHttpClientEventHandler`
  Parameters:
    `conn` - HTTP connection that caused timeout condition.
  Throws:
    `IOException`

### log

    protected void log(Exception ex)

  This method can be used to log I/O exception thrown while closing `Closeable` objects (such as `HttpConnection`}).

  Parameters:
    `ex` - I/O exception thrown by `Closeable.close()`

Copyright © 2005-2013 The Apache Software Foundation. All Rights Reserved.